//
//  ImageFrame.h
//  ATIKOSXDrivers
//
//  Created by Nick Kitchener on 04/11/2012.
//  Copyright (c) 2012 ATIK. All rights reserved.
//

#import <Foundation/Foundation.h>

typedef unsigned long long AOSXFileSize;

@interface ImageFrame : NSObject {
@private
    NSRect _cameraFrame;
}

@property(readwrite, nonatomic) NSPoint     binning;
@property(readwrite, nonatomic)  uint32_t    width;
@property(readwrite, nonatomic)  uint32_t    height;
@property(readwrite, nonatomic) NSRect      cameraFrame;
@property(readwrite, nonatomic) float       duration;
@property(readwrite, nonatomic) BOOL        preview;
@property(readwrite, nonatomic) BOOL        subsampled;
@property(readwrite, nonatomic) BOOL        oversampled;

@property(readwrite, nonatomic) uint32_t imagebufferSize;
@property(readwrite, nonatomic) uint8_t *imagebuffer;

-(id)initWithSize:(NSUInteger)size at:(NSURL*)fileURL;
-(void)dealloc;

// note that the self allocated memory buffer is released automatically
// if this object is garbage collected.
-(void)selfAllocate;
-(void)explicitReleaseSelfAllocated; // explicitly release self allocated memory.

-(void*)obj;

@end
